(function() {
  var recorder, shortid;

  shortid = require("shortid");

  recorder = require("./core/recorder");

  exports.add = function() {
    return recorder.dispatch("todo/add", {
      id: shortid.generate(),
      done: false,
      text: ""
    });
  };

  exports.update = function(id, text) {
    return recorder.dispatch("todo/update", {
      id: id,
      text: text
    });
  };

  exports.toggle = function(id) {
    return recorder.dispatch("todo/toggle", id);
  };

  exports.remove = function(id) {
    return recorder.dispatch("todo/remove", id);
  };

  exports.internalCommit = function() {
    return recorder.dispatch("actions-recorder/commit");
  };

  exports.internalSwitch = function() {
    return recorder.dispatch("actions-recorder/switch");
  };

  exports.internalReset = function() {
    return recorder.dispatch("actions-recorder/reset");
  };

  exports.internalPeek = function(position) {
    return recorder.dispatch("actions-recorder/peek", position);
  };

  exports.internalDiscard = function() {
    return recorder.dispatch("actions-recorder/discard");
  };

}).call(this);
