(function() {
  var Controller, Immutable, React, Todolist, actions, div, onCommit, onDiscard, onPeek, onReset, onSwitch, render;

  React = require("react");

  Immutable = require("immutable");

  actions = require("../actions");

  Todolist = React.createFactory(require("./todolist"));

  Controller = React.createFactory(require("../panel/controller"));

  div = React.createFactory("div");

  module.exports = React.createClass({
    displayName: "app-page",
    propTypes: {
      store: React.PropTypes.instanceOf(Immutable.List),
      recorder: React.PropTypes.object.isRequired
    },
    onCommit: onCommit = function() {
      return actions.internalCommit();
    },
    onSwitch: onSwitch = function() {
      return actions.internalSwitch();
    },
    onReset: onReset = function() {
      return actions.internalReset();
    },
    onPeek: onPeek = function(position) {
      return actions.internalPeek(position);
    },
    onDiscard: onDiscard = function() {
      return actions.internalDiscard();
    },
    render: render = function() {
      return div({
        className: "app-page"
      }, Todolist({
        store: this.props.store
      }), Controller({
        records: this.props.recorder.records,
        pointer: this.props.recorder.pointer,
        isTravelling: this.props.recorder.isTravelling,
        onCommit: this.onCommit,
        onSwitch: this.onSwitch,
        onReset: this.onReset,
        onPeek: this.onPeek,
        onDiscard: this.onDiscard
      }));
    }
  });

}).call(this);
